/**@file

// cpcAnalogAlarmConfig.ctl
This library contains the import and export function of the CPC_AnalogAlarm.

@par Creation Date
  dd/mm/yyyy

@par Modification History
  
@par Constraints
  None

@par Usage
  Public

@par PVSS managers
  Ui, CTRL

@author 
  the author (DEP-GROUP)

@copyright
        &copy;Copyright CERN 2013 - all rights reserved
*/
//@{



// Constants
const string UN_CONFIG_CPC_ANALOGALARM_DPT_NAME = "CPC_AnalogAlarm";
//begin_TAG_SCRIPT_DEVICE_TYPE_constants
const unsigned UN_CONFIG_CPC_ANALOGALARM_LENGTH = 24;

const unsigned UN_CONFIG_CPC_ANALOGALARM_UNIT					= 1;
const unsigned UN_CONFIG_CPC_ANALOGALARM_FORMAT					= 2;
const unsigned UN_CONFIG_CPC_ANALOGALARM_HHALST_ARCHIVE_ACTIVE  = 3;
const unsigned UN_CONFIG_CPC_ANALOGALARM_HWST_ARCHIVE_ACTIVE    = 3;
const unsigned UN_CONFIG_CPC_ANALOGALARM_LWST_ARCHIVE_ACTIVE    = 3;
const unsigned UN_CONFIG_CPC_ANALOGALARM_LLALST_ARCHIVE_ACTIVE  = 3;
const unsigned UN_CONFIG_CPC_ANALOGALARM_IST_ARCHIVE_ACTIVE     = 3;
const unsigned UN_CONFIG_CPC_ANALOGALARM_WST_ARCHIVE_ACTIVE     = 3;
const unsigned UN_CONFIG_CPC_ANALOGALARM_POSST_ARCHIVE_ACTIVE       = 4;
const unsigned UN_CONFIG_CPC_ANALOGALARM_POSST_ARCHIVE_TIME_FILTER  = 5;
const unsigned UN_CONFIG_CPC_ANALOGALARM_SMS_CATEGORIES				= 6;
const unsigned UN_CONFIG_CPC_ANALOGALARM_SMS_MESSAGE				= 7;
const unsigned UN_CONFIG_CPC_ANALOGALARM_ACK_ALARM					= 8;
const unsigned UN_CONFIG_CPC_ANALOGALARM_ALARM_LEVEL				= 9;
const unsigned UN_CONFIG_CPC_ANALOGALARM_NORMAL_POSITION			= 10;
const unsigned UN_CONFIG_CPC_ANALOGALARM_ADDRESS_STSREG01			= 11;
const unsigned UN_CONFIG_CPC_ANALOGALARM_ADDRESS_STSREG02			= 12;
const unsigned UN_CONFIG_CPC_ANALOGALARM_ADDRESS_EVSTSREG01		= 13;
const unsigned UN_CONFIG_CPC_ANALOGALARM_ADDRESS_EVSTSREG02		= 14;
const unsigned UN_CONFIG_CPC_ANALOGALARM_ADDRESS_POSST				= 15;
const unsigned UN_CONFIG_CPC_ANALOGALARM_ADDRESS_HHST				= 16;
const unsigned UN_CONFIG_CPC_ANALOGALARM_ADDRESS_HST				= 17;
const unsigned UN_CONFIG_CPC_ANALOGALARM_ADDRESS_LST				= 18;
const unsigned UN_CONFIG_CPC_ANALOGALARM_ADDRESS_LLST				= 19;
const unsigned UN_CONFIG_CPC_ANALOGALARM_ADDRESS_MANREG01			= 20;
const unsigned UN_CONFIG_CPC_ANALOGALARM_ADDRESS_HH				= 21;
const unsigned UN_CONFIG_CPC_ANALOGALARM_ADDRESS_H					= 22;
const unsigned UN_CONFIG_CPC_ANALOGALARM_ADDRESS_L					= 23;
const unsigned UN_CONFIG_CPC_ANALOGALARM_ADDRESS_LL				= 24;

const unsigned UN_CONFIG_CPC_ANALOGALARM_ADDITIONAL_LENGTH          = 7;
const unsigned UN_CONFIG_CPC_ANALOGALARM_ADDITIONAL_MASKEVENT       = 1;
const unsigned UN_CONFIG_CPC_ANALOGALARM_ADDITIONAL_PARAMETERS      = 2;
const unsigned UN_CONFIG_CPC_ANALOGALARM_ADDITIONAL_MASTER_NAME     = 3;
const unsigned UN_CONFIG_CPC_ANALOGALARM_ADDITIONAL_PARENTS         = 4;
const unsigned UN_CONFIG_CPC_ANALOGALARM_ADDITIONAL_CHILDREN        = 5;
const unsigned UN_CONFIG_CPC_ANALOGALARM_ADDITIONAL_TYPE            = 6;
const unsigned UN_CONFIG_CPC_ANALOGALARM_ADDITIONAL_SECOND_ALIAS    = 7;

const string UN_CONFIG_CPC_ANALOGALARM_HHALST_ALERT_TEXT   = "HH";
const string UN_CONFIG_CPC_ANALOGALARM_HWST_ALERT_TEXT     = "H";
const string UN_CONFIG_CPC_ANALOGALARM_LWST_ALERT_TEXT     = "L";
const string UN_CONFIG_CPC_ANALOGALARM_LLALST_ALERT_TEXT   = "LL";

const string UN_CONFIG_CPC_ANALOGALARM_HHALST_ALERT_CLASS_POSTFIX   = "HH";
const string UN_CONFIG_CPC_ANALOGALARM_HWST_ALERT_CLASS_POSTFIX     = "H";
const string UN_CONFIG_CPC_ANALOGALARM_LWST_ALERT_CLASS_POSTFIX     = "L";
const string UN_CONFIG_CPC_ANALOGALARM_LLALST_ALERT_CLASS_POSTFIX   = "LL";
//end_TAG_SCRIPT_DEVICE_TYPE_constants


/**
DPE configuration
TODO: use fw info instead
*/
mapping CPC_AnalogAlarmConfig_getConfig() {
  mapping config;
  mapping props;

//begin_TAG_SCRIPT_DEVICE_TYPE_deviceConfig
	mappingClear(props);
	props["address"] 		= ".ProcessInput.StsReg01";
	props["dataType"] 		= CPC_UINT16;
	config["StsReg01"] 		= props;

	mappingClear(props);
	props["address"] 		= ".ProcessInput.StsReg02";
	props["dataType"] 		= CPC_UINT16;
	config["StsReg02"] 		= props;

	mappingClear(props);
	props["hasArchive"] 	= true;
	props["address"] 		= ".ProcessInput.evStsReg01";
	props["dataType"] 		= CPC_INT32;
	config["evStsReg01"]	= props;

	mappingClear(props);
	props["hasArchive"] 	= true;
	props["address"] 		= ".ProcessInput.evStsReg02";
	props["dataType"] 		= CPC_INT32;
	config["evStsReg02"]	= props;

	mappingClear(props);
	props["hasUnit"] 		= true;
	props["hasFormat"] 		= true;
	props["hasArchive"] 	= true;
	props["address"] 		= ".ProcessInput.PosSt";
	props["dataType"] 		= CPC_FLOAT;
	config["PosSt"] 		= props;

	mappingClear(props);
	props["address"] 		= ".ProcessInput.HHSt";
	props["dataType"] 		= CPC_FLOAT;
	config["HHSt"] 			= props;

	mappingClear(props);
	props["address"] 		= ".ProcessInput.HSt";
	props["dataType"] 		= CPC_FLOAT;
	config["HSt"] 			= props;

	mappingClear(props);
	props["address"] 		= ".ProcessInput.LSt";
	props["dataType"] 		= CPC_FLOAT;
	config["LSt"] 			= props;

	mappingClear(props);
	props["address"] 		= ".ProcessInput.LLSt";
	props["dataType"] 		= CPC_FLOAT;
	config["LLSt"] 			= props;

	mappingClear(props);
	props["hasAcknowledge"] = true;
	props["hasArchive"] 	= true;
	props["address"] 		= ".ProcessInput.HHAlSt";
	props["dpe"]			= "StsReg02";
	props["bitPosition"]	= CPC_STSREG02_HHALST;
	props["isAlarm"]		= true;
	config["HHAlSt"] 		= props;

	mappingClear(props);
	props["hasAcknowledge"] = false;
	props["hasArchive"] 	= true;
	props["address"] 		= ".ProcessInput.HWSt";
	props["dpe"]			= "StsReg02";
	props["bitPosition"]	= CPC_STSREG02_HWST;
	props["isAlarm"]		= true;
	config["HWSt"] 		    = props;

	mappingClear(props);
	props["hasAcknowledge"] = false;
	props["hasArchive"] 	= true;
	props["address"] 		= ".ProcessInput.LWSt";
	props["dpe"]			= "StsReg02";
	props["bitPosition"]	= CPC_STSREG02_LWST;
	props["isAlarm"]		= true;
	config["LWSt"] 		    = props;

	mappingClear(props);
	props["hasAcknowledge"] = true;
	props["hasArchive"] 	= true;
	props["address"] 		= ".ProcessInput.LLAlSt";
	props["dpe"]			= "StsReg02";
	props["bitPosition"]	= CPC_STSREG02_LLALST;
	props["isAlarm"]		= true;
	config["LLAlSt"] 		= props;

	mappingClear(props);
	props["hasArchive"]   = true;
	props["address"]      = ".ProcessInput.ISt";
	props["dpe"]          = "StsReg01";
	props["bitPosition"]  = CPC_STSREG01_IST;
	props["dataType"]     = CPC_BOOL;
	config["ISt"]         = props;

	mappingClear(props);
	props["hasArchive"]   = true;
	props["address"]      = ".ProcessInput.WSt";
	props["dpe"]          = "StsReg01";
	props["bitPosition"]  = CPC_STSREG01_WST;
	props["dataType"]     = CPC_BOOL;
	config["WSt"]         = props;

	mappingClear(props);
	props["address"] 		= ".ProcessOutput.ManReg01";
	props["dataType"] 		= CPC_UINT16;
	config["ManReg01"] 		= props;

	mappingClear(props);
	props["hasUnit"]                = true;
	props["hasFormat"]              = true;
	props["address"]                = ".ProcessOutput.HH";
	props["dataType"] 		          = CPC_FLOAT;
	config["HH"] 			              = props;

	mappingClear(props);
	props["hasUnit"]                = true;
	props["hasFormat"]              = true;
	props["address"]                = ".ProcessOutput.H";
	props["dataType"]               = CPC_FLOAT;
	config["H"]                     = props;

	mappingClear(props);
	props["hasUnit"]                = true;
	props["hasFormat"]              = true;
	props["address"]                = ".ProcessOutput.L";
	props["dataType"]               = CPC_FLOAT;
	config["L"]                     = props;

	mappingClear(props);
	props["hasUnit"]                = true;
	props["hasFormat"]              = true;
	props["address"] 		            = ".ProcessOutput.LL";
	props["dataType"] 		          = CPC_FLOAT;
	config["LL"] 			              = props;
//end_TAG_SCRIPT_DEVICE_TYPE_deviceConfig

  return config;
}

/**
Returns the list of parameter names that passed via config line.
*/
dyn_string CPC_AnalogAlarmConfig_getParamNames() {
//begin_TAG_SCRIPT_DEVICE_TYPE_getParamNames
	return makeDynString(CPC_PARAMS_ALDT);
//end_TAG_SCRIPT_DEVICE_TYPE_getParamNames
}

/**
Check data before configuration
  @param[in]  configLine   Configs (see dyn_string indexes in constants defined)
  @param[out] exceptionInfo All possible errors will be returned here
*/
CPC_AnalogAlarmConfig_checkConfig(dyn_string configLine, dyn_string &exceptionInfo)
{
  if (dynlen(configLine) >= UN_CONFIG_COMMON_LENGTH) {
    // 1. Common
    unConfigGenericFunctions_checkParameters(configLine, UN_CONFIG_CPC_ANALOGALARM_DPT_NAME, exceptionInfo);
    // 2. call the device check function
    unConfigGenericFunctions_checkDeviceConfig(configLine, UN_CONFIG_CPC_ANALOGALARM_DPT_NAME, exceptionInfo);
  } else {
    fwException_raise(exceptionInfo,"ERROR","CPC_AnalogAlarmConfig_checkConfig: " + getCatStr("unGeneration","BADINPUTS"),"");
  }
}

/**
Check the CPC_AnalogAlarm device configuration for the S7_PLC front-end
  @param dsConfigs input, config line as dyn_string
  @param exceptionInfo output, for errors
*/
S7_PLC_CPC_AnalogAlarm_checkConfig(dyn_string configLine, dyn_string &exceptionInfo)
{
  cpcConfigGenericFunctions_checkDeviceConfig(UN_CONFIG_CPC_ANALOGALARM_DPT_NAME, configLine, exceptionInfo);
}

/**
Check the CPC_AnalogAlarm device configuration for the _UnPlc front-end
  @param dsConfigs input, config line as dyn_string
  @param exceptionInfo output, for errors
*/
_UnPlc_CPC_AnalogAlarm_checkConfig(dyn_string configLine, dyn_string &exceptionInfo)
{
  cpcConfigGenericFunctions_checkDeviceConfig(UN_CONFIG_CPC_ANALOGALARM_DPT_NAME, configLine, exceptionInfo);
}

/** Check custom configuration
*/
CPC_AnalogAlarmConfig_checkCustomConfig(dyn_string configLine, bool hasArchive, dyn_string &exceptionInfo)
{
//begin_TAG_SCRIPT_DEVICE_TYPE_checkCustomConfig
  int alarmLevel;
  unConfigGenericFunctions_checkInt(configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_ANALOGALARM_ALARM_LEVEL], alarmLevel, exceptionInfo);
  if (dynlen(exceptionInfo) > 0) return;
  if (alarmLevel < 0 || alarmLevel > 3) {
      fwException_raise(exceptionInfo, "ERROR", "CPC_AnalogAlarmConfig_checkCustomConfig: wrong alarm level: '" + configLine[UN_CONFIG_COMMON_LENGTH + UN_CONFIG_CPC_ANALOGALARM_ALARM_LEVEL] + "'", "");
      return;
  }
//end_TAG_SCRIPT_DEVICE_TYPE_checkCustomConfig
}

/**
Creates dp (or checks if it is already presented)and sets configuration for CPC_AnalogAlarm object.
  
  @param[in]  dsConfigs   Configs (see dyn_string indexes in constants defined)
    dsConfigs is the addition of the file configuration line + additional parameters needed for PVSS. These additional parameters
    are added during the import process. Their contents can be accessed using constants defined in unConfigGenericFunctions.ctl library
  @param[out] exceptionInfo All possible errors will be returned here
*/
CPC_AnalogAlarmConfig_setConfig(dyn_string dsConfigs, dyn_string &exceptionInfo)
{
  string sDpName;

  // 1. Initialization : checking + dpCreate
  unConfigGenericFunctions_checkAll(dsConfigs, UN_CONFIG_CPC_ANALOGALARM_DPT_NAME, exceptionInfo);
  if (dynlen(exceptionInfo) <= 0) { // Good inputs 
    sDpName = dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME];
    unConfigGenericFunctions_createDp(sDpName, UN_CONFIG_CPC_ANALOGALARM_DPT_NAME, exceptionInfo);
    if (dynlen(exceptionInfo) <= 0) { // Creation ok or dp already exists
      // 2. Generate device
      // 2.1. Parameters
      unConfigGenericFunctions_setCommon(dsConfigs, exceptionInfo);
      // 2.2 call the device check function
      unConfigGenericFunctions_setDeviceConfig(dsConfigs, UN_CONFIG_CPC_ANALOGALARM_DPT_NAME, exceptionInfo);
    }
  }
}

/**
Set the CPC_AnalogAlarm device configuration for the S7_PLC front-end
  @param dsConfigs input, config line as dyn_string
  @param exceptionInfo output, for errors
*/
S7_PLC_CPC_AnalogAlarm_setConfig(dyn_string dsConfigs, dyn_string &exceptionInfo)
{
  cpcConfigGenericFunctions_setDeviceConfig(dsConfigs, exceptionInfo);
}

/**
Set the CPC_AnalogAlarm device configuration for the _UnPlc front-end
  @param dsConfigs input, config line as dyn_string
  @param exceptionInfo output, for errors
*/
_UnPlc_CPC_AnalogAlarm_setConfig(dyn_string dsConfigs, dyn_string &exceptionInfo)
{
  cpcConfigGenericFunctions_setDeviceConfig(dsConfigs, exceptionInfo);
}

/** Set custom configuration
*/
CPC_AnalogAlarmConfig_setCustomConfig(dyn_string dsConfigs, bool hasArchive, dyn_string &exceptionInfo)
{
//begin_TAG_SCRIPT_DEVICE_TYPE_setCustomConfig
  unGenericDpFunctions_setKeyDeviceConfiguration(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME], CPC_CONFIG_ALARM_LEVEL, makeDynString(dsConfigs[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CPC_ANALOGALARM_ALARM_LEVEL]), exceptionInfo);
  
  fwArchive_set(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessInput.HHSt", dsConfigs[UN_CONFIG_OBJECTGENERAL_ARCHIVE_ANALOG], DPATTR_ARCH_PROC_SIMPLESM, DPATTR_COMPARE_OLD_NEW, 0, 0, exceptionInfo);
  fwArchive_set(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessInput.HSt",  dsConfigs[UN_CONFIG_OBJECTGENERAL_ARCHIVE_ANALOG], DPATTR_ARCH_PROC_SIMPLESM, DPATTR_COMPARE_OLD_NEW, 0, 0, exceptionInfo);
  fwArchive_set(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessInput.LSt",  dsConfigs[UN_CONFIG_OBJECTGENERAL_ARCHIVE_ANALOG], DPATTR_ARCH_PROC_SIMPLESM, DPATTR_COMPARE_OLD_NEW, 0, 0, exceptionInfo);
  fwArchive_set(dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessInput.LLSt", dsConfigs[UN_CONFIG_OBJECTGENERAL_ARCHIVE_ANALOG], DPATTR_ARCH_PROC_SIMPLESM, DPATTR_COMPARE_OLD_NEW, 0, 0, exceptionInfo);
//end_TAG_SCRIPT_DEVICE_TYPE_setCustomConfig
}

/**
Purpose: Export CPC_AnalogAlarm Devices

Usage: External function

PVSS manager usage: NG, NV
*/
CPC_AnalogAlarmConfig_ExportConfig(dyn_string dsDpList, dyn_string &exceptionInfo)
{
    string sObject = UN_CONFIG_CPC_ANALOGALARM_DPT_NAME;
    int amount = dynlen(dsDpList);
    for(int i = 1; i <= amount; i++) {
        dyn_string dsDpParameters;
        string currentDP = dsDpList[i];

        if(!dpExists(currentDP)) continue;

        unExportDevice_getAllCommonParameters(currentDP, sObject, dsDpParameters);
//begin_TAG_SCRIPT_DEVICE_TYPE_export
        cpcExportGenericFunctions_getUnit(currentDP, dsDpParameters);
        cpcExportGenericFunctions_getFormat(currentDP, dsDpParameters);
        cpcExportGenericFunctions_getArchive(currentDP, dsDpParameters, ".ProcessInput.HHAlSt");
        dynRemove(dsDpParameters, dynlen(dsDpParameters));
        cpcExportGenericFunctions_getArchive(currentDP, dsDpParameters, ".ProcessInput.PosSt");
        cpcExportGenericFunctions_getCategories(currentDP, dsDpParameters, exceptionInfo);
        cpcExportGenericFunctions_getKeyDeviceConfiguration(currentDP, dsDpParameters, CPC_CONFIG_SMS_MESSAGE, exceptionInfo);
        cpcExportGenericFunctions_getAcknowledgeAlarm(currentDP, ".ProcessInput.HHAlSt", dsDpParameters, exceptionInfo);
        cpcExportGenericFunctions_getKeyDeviceConfiguration(currentDP, dsDpParameters, CPC_CONFIG_ALARM_LEVEL, exceptionInfo);
        cpcExportGenericFunctions_getDigitalNormalPosition(currentDP, sObject, makeDynString(".ProcessInput.HHAlSt"), dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "StsReg01", 	true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "StsReg02", 	true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "evStsReg01", 	true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "evStsReg02", 	true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "PosSt", 		true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "HHSt", 		true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "HSt", 		true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "LSt", 		true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "LLSt", 		true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "ManReg01", 	false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "HH", 			false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "H", 			false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "L", 			false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "LL", 			false, dsDpParameters);
        cpcExportGenericFunctions_getArchiveNameForDpes(currentDP, UN_CONFIG_EXPORT_ARCHIVE_1, makeDynString("ProcessInput.HHAlSt", "ProcessInput.HWSt", "ProcessInput.LWSt", "ProcessInput.LLAlSt"), dsDpParameters);
        cpcExportGenericFunctions_getArchiveNameForDpes(currentDP, UN_CONFIG_EXPORT_ARCHIVE_2, makeDynString("ProcessInput.PosSt", "ProcessInput.HHSt", "ProcessInput.HSt", "ProcessInput.LSt", "ProcessInput.LLSt"), dsDpParameters);
        cpcExportGenericFunctions_getArchiveNameForDpes(currentDP, UN_CONFIG_EXPORT_ARCHIVE_3, makeDynString("ProcessInput.evStsReg01", "ProcessInput.evStsReg02"), dsDpParameters);
        cpcExportGenericFunctions_getMaskEvent(currentDP, dsDpParameters);
        cpcExportGenericFunctions_getParameters(currentDP, dsDpParameters, exceptionInfo);
        cpcExportGenericFunctions_getMetainfo(currentDP, dsDpParameters, exceptionInfo);
//end_TAG_SCRIPT_DEVICE_TYPE_export

        unExportDevice_writeDsStringToFile(dsDpParameters, UN_PARAMETER_DELIMITER);
    }
}

/**
Purpose: Export CPC_AnalogAlarm Devices for S7_PLC front-end

Usage: External function

PVSS manager usage: NG, NV
*/
S7_PLC_CPC_AnalogAlarm_ExportConfig(dyn_string dsDpList, dyn_string &exceptionInfo)
{
    CPC_AnalogAlarmConfig_ExportConfig(dsDpList, exceptionInfo);
}

/**
Purpose: Export CPC_AnalogAlarm Devices for _UnPlc front-end

Usage: External function

PVSS manager usage: NG, NV
*/
_UnPlc_CPC_AnalogAlarm_ExportConfig(dyn_string dsDpList, dyn_string &exceptionInfo)
{
    CPC_AnalogAlarmConfig_ExportConfig(dsDpList, exceptionInfo);
}

//@}