/**@file

// cpcAnalogInputConfig.ctl
This library contains the import and export function of the CPC_AnalogInput.

@par Creation Date
  dd/mm/yyyy

@par Modification History
  
@par Constraints
  None

@par Usage
  Public

@par PVSS managers
  Ui, CTRL

@author 
  the author (DEP-GROUP)

@copyright
        &copy;Copyright CERN 2013 - all rights reserved
*/
//@{



// Constants
const string UN_CONFIG_CPC_ANALOGINPUT_DPT_NAME = "CPC_AnalogInput";
//begin_TAG_SCRIPT_DEVICE_TYPE_constants
const unsigned UN_CONFIG_CPC_ANALOGINPUT_LENGTH = 22;

const unsigned UN_CONFIG_CPC_ANALOGINPUT_UNIT                       = 1;
const unsigned UN_CONFIG_CPC_ANALOGINPUT_FORMAT                     = 2;
const unsigned UN_CONFIG_CPC_ANALOGINPUT_RANGEMAX                   = 3;
const unsigned UN_CONFIG_CPC_ANALOGINPUT_RANGEMIN                   = 4;
const unsigned UN_CONFIG_CPC_ANALOGINPUT_HHLIMIT                    = 5;
const unsigned UN_CONFIG_CPC_ANALOGINPUT_HLIMIT                     = 6;
const unsigned UN_CONFIG_CPC_ANALOGINPUT_LLIMIT                     = 7;
const unsigned UN_CONFIG_CPC_ANALOGINPUT_LLLIMIT                    = 8;
const unsigned UN_CONFIG_CPC_ANALOGINPUT_ALARM_ACTIVE               = 9;
const unsigned UN_CONFIG_CPC_ANALOGINPUT_DEADBAND                   = 10;
const unsigned UN_CONFIG_CPC_ANALOGINPUT_DEADBAND_TYPE              = 11;
const unsigned UN_CONFIG_CPC_ANALOGINPUT_ARCHIVE_ACTIVE             = 12;
const unsigned UN_CONFIG_CPC_ANALOGINPUT_ARCHIVE_TIME_FILTER        = 13;
const unsigned UN_CONFIG_CPC_ANALOGINPUT_SMS_CATEGORIES             = 14;
const unsigned UN_CONFIG_CPC_ANALOGINPUT_SMS_MESSAGE                = 15;
const unsigned UN_CONFIG_CPC_ANALOGINPUT_ACK_ALARM                  = 16;
const unsigned UN_CONFIG_CPC_ANALOGINPUT_ADDRESS_STSREG01           = 17;
const unsigned UN_CONFIG_CPC_ANALOGINPUT_ADDRESS_EVSTSREG01         = 18;
const unsigned UN_CONFIG_CPC_ANALOGINPUT_ADDRESS_POSST              = 19;
const unsigned UN_CONFIG_CPC_ANALOGINPUT_ADDRESS_HFST               = 20;
const unsigned UN_CONFIG_CPC_ANALOGINPUT_ADDRESS_MANREG01           = 21;
const unsigned UN_CONFIG_CPC_ANALOGINPUT_ADDRESS_MPOSR              = 22;

const unsigned UN_CONFIG_CPC_ANALOGINPUT_ADDITIONAL_LENGTH          = 7;
const unsigned UN_CONFIG_CPC_ANALOGINPUT_ADDITIONAL_MASKEVENT       = 1;
const unsigned UN_CONFIG_CPC_ANALOGINPUT_ADDITIONAL_PARAMETERS      = 2;
const unsigned UN_CONFIG_CPC_ANALOGINPUT_ADDITIONAL_MASTER_NAME     = 3;
const unsigned UN_CONFIG_CPC_ANALOGINPUT_ADDITIONAL_PARENTS         = 4;
const unsigned UN_CONFIG_CPC_ANALOGINPUT_ADDITIONAL_CHILDREN        = 5;
const unsigned UN_CONFIG_CPC_ANALOGINPUT_ADDITIONAL_TYPE            = 6;
const unsigned UN_CONFIG_CPC_ANALOGINPUT_ADDITIONAL_SECOND_ALIAS    = 7;

// SOFT_FE constants
const unsigned UN_CONFIG_SOFT_FE_CPC_ANALOGINPUT_UNIT                  = 1;
const unsigned UN_CONFIG_SOFT_FE_CPC_ANALOGINPUT_FORMAT                = 2;
const unsigned UN_CONFIG_SOFT_FE_CPC_ANALOGINPUT_RANGEMAX              = 3;
const unsigned UN_CONFIG_SOFT_FE_CPC_ANALOGINPUT_RANGEMIN              = 4;
const unsigned UN_CONFIG_SOFT_FE_CPC_ANALOGINPUT_HHLIMIT               = 5;
const unsigned UN_CONFIG_SOFT_FE_CPC_ANALOGINPUT_HLIMIT                = 6;
const unsigned UN_CONFIG_SOFT_FE_CPC_ANALOGINPUT_LLIMIT                = 7;
const unsigned UN_CONFIG_SOFT_FE_CPC_ANALOGINPUT_LLLIMIT               = 8;
const unsigned UN_CONFIG_SOFT_FE_CPC_ANALOGINPUT_ALARM_ACTIVE          = 9;
const unsigned UN_CONFIG_SOFT_FE_CPC_ANALOGINPUT_ARCHIVE_ACTIVE        = 10;
const unsigned UN_CONFIG_SOFT_FE_CPC_ANALOGINPUT_ARCHIVE_TIME_FILTER   = 11;
const unsigned UN_CONFIG_SOFT_FE_CPC_ANALOGINPUT_SMS_CATEGORIES        = 12;
const unsigned UN_CONFIG_SOFT_FE_CPC_ANALOGINPUT_SMS_MESSAGE           = 13;
const unsigned UN_CONFIG_SOFT_FE_CPC_ANALOGINPUT_ACK_ALARM             = 14;
const unsigned UN_CONFIG_SOFT_FE_CPC_ANALOGINPUT_LENGTH                = 14;

const unsigned UN_CONFIG_SOFT_FE_CPC_ANALOGINPUT_ADDITIONAL_LENGTH     = 1;
const unsigned UN_CONFIG_SOFT_FE_CPC_ANALOGINPUT_ADDITIONAL_MASKEVENT  = 1;

// CMW constants
const unsigned UN_CONFIG_CMW_CPC_ANALOGINPUT_UNIT                       = 1;
const unsigned UN_CONFIG_CMW_CPC_ANALOGINPUT_FORMAT                     = 2;
const unsigned UN_CONFIG_CMW_CPC_ANALOGINPUT_RANGEMAX                   = 3;
const unsigned UN_CONFIG_CMW_CPC_ANALOGINPUT_RANGEMIN                   = 4;
const unsigned UN_CONFIG_CMW_CPC_ANALOGINPUT_HHLIMIT                    = 5;
const unsigned UN_CONFIG_CMW_CPC_ANALOGINPUT_HLIMIT                     = 6;
const unsigned UN_CONFIG_CMW_CPC_ANALOGINPUT_LLIMIT                     = 7;
const unsigned UN_CONFIG_CMW_CPC_ANALOGINPUT_LLLIMIT                    = 8;
const unsigned UN_CONFIG_CMW_CPC_ANALOGINPUT_ALARM_ACTIVE               = 9;
const unsigned UN_CONFIG_CMW_CPC_ANALOGINPUT_DEADBAND                   = 10;
const unsigned UN_CONFIG_CMW_CPC_ANALOGINPUT_DEADBAND_TYPE              = 11;
const unsigned UN_CONFIG_CMW_CPC_ANALOGINPUT_ARCHIVE_ACTIVE             = 12;
const unsigned UN_CONFIG_CMW_CPC_ANALOGINPUT_ARCHIVE_TIME_FILTER        = 13;
const unsigned UN_CONFIG_CMW_CPC_ANALOGINPUT_SMS_CATEGORIES             = 14;
const unsigned UN_CONFIG_CMW_CPC_ANALOGINPUT_SMS_MESSAGE                = 15;
const unsigned UN_CONFIG_CMW_CPC_ANALOGINPUT_ACK_ALARM                  = 16;
const unsigned UN_CONFIG_CMW_CPC_ANALOGINPUT_ADDRESS_STSREG01           = 17;
const unsigned UN_CONFIG_CMW_CPC_ANALOGINPUT_ADDRESS_EVSTSREG01         = 18;
const unsigned UN_CONFIG_CMW_CPC_ANALOGINPUT_ADDRESS_POSST              = 19;
const unsigned UN_CONFIG_CMW_CPC_ANALOGINPUT_ADDRESS_HFST     = 20;
const unsigned UN_CONFIG_CMW_CPC_ANALOGINPUT_LENGTH                     = 20;

const unsigned UN_CONFIG_CMW_CPC_ANALOGINPUT_ADDITIONAL_LENGTH          = 1;
const unsigned UN_CONFIG_CMW_CPC_ANALOGINPUT_ADDITIONAL_MASKEVENT       = 1;
//end_TAG_SCRIPT_DEVICE_TYPE_constants


/**
DPE configuration
TODO: use fw info instead
*/
mapping CPC_AnalogInputConfig_getConfig() {
  mapping config;
  mapping props;

//begin_TAG_SCRIPT_DEVICE_TYPE_deviceConfig
    mappingClear(props);
    props["address"]            = ".ProcessInput.StsReg01";
    props["dataType"]           = CPC_UINT16;
    config["StsReg01"]          = props;

    mappingClear(props);
    props["hasArchive"]         = true;
    props["address"]            = ".ProcessInput.evStsReg01";
    props["dataType"]           = CPC_INT32;
    config["evStsReg01"]        = props;

    mappingClear(props);
    props["5RangesAlerts"]      = true;
    props["hasUnit"]            = true;
    props["hasFormat"]          = true;
    props["hasArchive"]         = true;
    props["hasPvRange"]         = true;
    props["hasSmooth"]          = true;
    props["address"]            = ".ProcessInput.PosSt";
    props["dataType"]           = CPC_FLOAT;
    config["PosSt"]             = props;

    mappingClear(props);
    props["hasUnit"]            = true;
    props["hasFormat"]          = true;
    props["hasSmooth"]          = true;
    props["address"]            = ".ProcessInput.HFSt";
    props["dataType"]           = CPC_FLOAT;
    config["HFSt"]    = props;

    if (cpcConfigGenericFunctions_getFrontEndType() != CPC_CMW_DPTYPE) {
    mappingClear(props);
    props["address"]            = ".ProcessOutput.ManReg01";
    props["dataType"]           = CPC_UINT16;
    config["ManReg01"]          = props;

    mappingClear(props);
    props["address"]            = ".ProcessOutput.MPosR";
    props["dataType"]           = CPC_FLOAT;
    config["MPosR"]             = props;
    }
//end_TAG_SCRIPT_DEVICE_TYPE_deviceConfig

  return config;
}

/**
Check data before configuration
  @param[in]  configLine   Configs (see dyn_string indexes in constants defined)
  @param[out] exceptionInfo All possible errors will be returned here
*/
CPC_AnalogInputConfig_checkConfig(dyn_string configLine, dyn_string &exceptionInfo)
{
  if (dynlen(configLine) >= UN_CONFIG_COMMON_LENGTH) {
    // 1. Common
    unConfigGenericFunctions_checkParameters(configLine, UN_CONFIG_CPC_ANALOGINPUT_DPT_NAME, exceptionInfo);
    // 2. call the device check function
    unConfigGenericFunctions_checkDeviceConfig(configLine, UN_CONFIG_CPC_ANALOGINPUT_DPT_NAME, exceptionInfo);
  } else {
    fwException_raise(exceptionInfo,"ERROR","CPC_AnalogInputConfig_checkConfig: " + getCatStr("unGeneration","BADINPUTS"),"");
  }
}

/**
Check the CPC_AnalogInput device configuration for the SOFT_FE front-end
  @param dsConfigs input, config line as dyn_string
  @param exceptionInfo output, for errors
*/
SOFT_FE_CPC_AnalogInput_checkConfig(dyn_string configLine, dyn_string &exceptionInfo)
{
  cpcConfigGenericFunctions_checkDeviceConfig(UN_CONFIG_CPC_ANALOGINPUT_DPT_NAME, configLine, exceptionInfo);
}

/**
Check the CPC_AnalogInput device configuration for the CMW front-end
  @param dsConfigs input, config line as dyn_string
  @param exceptionInfo output, for errors
*/
CMW_CPC_AnalogInput_checkConfig(dyn_string configLine, dyn_string &exceptionInfo)
{
  cpcConfigGenericFunctions_checkDeviceConfig(UN_CONFIG_CPC_ANALOGINPUT_DPT_NAME, configLine, exceptionInfo);
}

/**
Check the CPC_AnalogInput device configuration for the S7_PLC front-end
  @param dsConfigs input, config line as dyn_string
  @param exceptionInfo output, for errors
*/
S7_PLC_CPC_AnalogInput_checkConfig(dyn_string configLine, dyn_string &exceptionInfo)
{
  cpcConfigGenericFunctions_checkDeviceConfig(UN_CONFIG_CPC_ANALOGINPUT_DPT_NAME, configLine, exceptionInfo);
}

/**
Check the CPC_AnalogInput device configuration for the _UnPlc front-end
  @param dsConfigs input, config line as dyn_string
  @param exceptionInfo output, for errors
*/
_UnPlc_CPC_AnalogInput_checkConfig(dyn_string configLine, dyn_string &exceptionInfo)
{
  cpcConfigGenericFunctions_checkDeviceConfig(UN_CONFIG_CPC_ANALOGINPUT_DPT_NAME, configLine, exceptionInfo);
}

/**
Creates dp (or checks if it is already presented)and sets configuration for CPC_AnalogInput object.
  
  @param[in]  dsConfigs   Configs (see dyn_string indexes in constants defined)
    dsConfigs is the addition of the file configuration line + additional parameters needed for PVSS. These additional parameters
    are added during the import process. Their contents can be accessed using constants defined in unConfigGenericFunctions.ctl library
  @param[out] exceptionInfo All possible errors will be returned here
*/
CPC_AnalogInputConfig_setConfig(dyn_string dsConfigs, dyn_string &exceptionInfo)
{
  string sDpName;

  // 1. Initialization : checking + dpCreate
  unConfigGenericFunctions_checkAll(dsConfigs, UN_CONFIG_CPC_ANALOGINPUT_DPT_NAME, exceptionInfo);
  if (dynlen(exceptionInfo) <= 0) { // Good inputs 
    sDpName = dsConfigs[UN_CONFIG_OBJECTGENERAL_DPNAME];
    unConfigGenericFunctions_createDp(sDpName, UN_CONFIG_CPC_ANALOGINPUT_DPT_NAME, exceptionInfo);
    if (dynlen(exceptionInfo) <= 0) { // Creation ok or dp already exists
      // 2. Generate device
      // 2.1. Parameters
      unConfigGenericFunctions_setCommon(dsConfigs, exceptionInfo);
      // 2.2 call the device check function
      unConfigGenericFunctions_setDeviceConfig(dsConfigs, UN_CONFIG_CPC_ANALOGINPUT_DPT_NAME, exceptionInfo);
    }
  }
}

/**
Set the CPC_AnalogInput device configuration for the SOFT_FE front-end
  @param dsConfigs input, config line as dyn_string
  @param exceptionInfo output, for errors
*/
SOFT_FE_CPC_AnalogInput_setConfig(dyn_string dsConfigs, dyn_string &exceptionInfo)
{
  cpcConfigGenericFunctions_setDeviceConfig(dsConfigs, exceptionInfo);
}

/**
Set the CPC_AnalogInput device configuration for the CMW front-end
  @param dsConfigs input, config line as dyn_string
  @param exceptionInfo output, for errors
*/
CMW_CPC_AnalogInput_setConfig(dyn_string dsConfigs, dyn_string &exceptionInfo)
{
  cpcConfigGenericFunctions_setDeviceConfig(dsConfigs, exceptionInfo);
}

/**
Set the CPC_AnalogInput device configuration for the S7_PLC front-end
  @param dsConfigs input, config line as dyn_string
  @param exceptionInfo output, for errors
*/
S7_PLC_CPC_AnalogInput_setConfig(dyn_string dsConfigs, dyn_string &exceptionInfo)
{
  cpcConfigGenericFunctions_setDeviceConfig(dsConfigs, exceptionInfo);
}

/**
Set the CPC_AnalogInput device configuration for the _UnPlc front-end
  @param dsConfigs input, config line as dyn_string
  @param exceptionInfo output, for errors
*/
_UnPlc_CPC_AnalogInput_setConfig(dyn_string dsConfigs, dyn_string &exceptionInfo)
{
  cpcConfigGenericFunctions_setDeviceConfig(dsConfigs, exceptionInfo);
}

/**
Purpose: Export CPC_AnalogInput Devices

Usage: External function

PVSS manager usage: NG, NV
*/
CPC_AnalogInputConfig_ExportConfig(dyn_string dsDpList, dyn_string &exceptionInfo)
{
    string sObject = UN_CONFIG_CPC_ANALOGINPUT_DPT_NAME;
    int amount = dynlen(dsDpList);
    for(int i = 1; i <= amount; i++) {
        dyn_string dsDpParameters;
        string currentDP = dsDpList[i];

        if(!dpExists(currentDP)) continue;

        unExportDevice_getAllCommonParameters(currentDP, sObject, dsDpParameters);
//begin_TAG_SCRIPT_DEVICE_TYPE_export
        cpcExportGenericFunctions_getUnit(currentDP, dsDpParameters, ".ProcessInput.PosSt");
        cpcExportGenericFunctions_getFormat(currentDP, dsDpParameters, ".ProcessInput.PosSt");
        cpcExportGenericFunctions_getRange(currentDP, dsDpParameters, exceptionInfo, ".ProcessInput.PosSt");
        cpcExportGenericFunctions_get5AlertLimits(currentDP, dsDpParameters);
        cpcExportGenericFunctions_getAlarmActive(currentDP, dsDpParameters);
        cpcExportGenericFunctions_getDeadband(currentDP, dsDpParameters, exceptionInfo, ".ProcessInput.PosSt");
        cpcExportGenericFunctions_getArchive(currentDP, dsDpParameters);
        cpcExportGenericFunctions_getCategories(currentDP, dsDpParameters, exceptionInfo);
        cpcExportGenericFunctions_getKeyDeviceConfiguration(currentDP, dsDpParameters, CPC_CONFIG_SMS_MESSAGE, exceptionInfo);
        cpcExportGenericFunctions_get5AlertAcknowledgeAlarm(currentDP, ".ProcessInput.PosSt", dsDpParameters, exceptionInfo);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "StsReg01",        true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "evStsReg01",      true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "PosSt",           true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "HFSt",  true, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "ManReg01",        false, dsDpParameters);
        cpcExportGenericFunctions_processAddress(currentDP, sObject, "MPosR",           false, dsDpParameters);
        cpcExportGenericFunctions_getArchiveNameForDpes(currentDP, UN_CONFIG_EXPORT_ARCHIVE_1, makeDynString(), dsDpParameters);
        cpcExportGenericFunctions_getArchiveNameForDpes(currentDP, UN_CONFIG_EXPORT_ARCHIVE_2, makeDynString("ProcessInput.PosSt"), dsDpParameters);
        cpcExportGenericFunctions_getArchiveNameForDpes(currentDP, UN_CONFIG_EXPORT_ARCHIVE_3, makeDynString("ProcessInput.evStsReg01"), dsDpParameters);
        cpcExportGenericFunctions_getMaskEvent(currentDP, dsDpParameters);
        cpcExportGenericFunctions_getParameters(currentDP, dsDpParameters, exceptionInfo);
        cpcExportGenericFunctions_getMetainfo(currentDP, dsDpParameters, exceptionInfo);
//end_TAG_SCRIPT_DEVICE_TYPE_export

        unExportDevice_writeDsStringToFile(dsDpParameters, UN_PARAMETER_DELIMITER);
    }
}

/**
Purpose: Export CPC_AnalogInput Devices for S7_PLC front-end

Usage: External function

PVSS manager usage: NG, NV
*/
S7_PLC_CPC_AnalogInput_ExportConfig(dyn_string dsDpList, dyn_string &exceptionInfo)
{
    CPC_AnalogInputConfig_ExportConfig(dsDpList, exceptionInfo);
}

/**
Purpose: Export CPC_AnalogInput Devices for _UnPlc front-end

Usage: External function

PVSS manager usage: NG, NV
*/
_UnPlc_CPC_AnalogInput_ExportConfig(dyn_string dsDpList, dyn_string &exceptionInfo)
{
    CPC_AnalogInputConfig_ExportConfig(dsDpList, exceptionInfo);
}

/*
  Use this place to define any unexisting constants or functions than you need for the device implementation.
*/
//begin_TAG_SCRIPT_DEVICE_TYPE_CustomConfigFunctions
CPC_CMW_AnalogInputConfig_setCustomConfig(dyn_string configLine, bool hasArchive, dyn_string &exceptionInfo) {
    if (configLine[UN_CONFIG_ALLCOMMON_LENGTH + UN_CONFIG_CMW_CPC_ANALOGINPUT_ADDRESS_STSREG01] == "") {
        dpSetWait(configLine[UN_CONFIG_OBJECTGENERAL_DPNAME] + ".ProcessInput.StsReg01", pow(2, UN_STSREG01_AUMOST) + pow(2, UN_STSREG01_AUINHFMO));
    }
}

void SOFT_FE_CPC_AnalogInput_ExportConfig(dyn_string dsDpList, dyn_string &exceptionInfo)
{
    string sObject = UN_CONFIG_CPC_ANALOGINPUT_DPT_NAME;
    int amount = dynlen(dsDpList);
    for(int i = 1; i <= amount; i++) {
        dyn_string dsDpParameters;
        string currentDP = dsDpList[i];

        if(!dpExists(currentDP)) continue;

        unExportDevice_getAllCommonParameters(currentDP, sObject, dsDpParameters);
        cpcExportGenericFunctions_getUnit(currentDP, dsDpParameters, ".ProcessInput.PosSt");
        cpcExportGenericFunctions_getFormat(currentDP, dsDpParameters, ".ProcessInput.PosSt");
        cpcExportGenericFunctions_getRange(currentDP, dsDpParameters, exceptionInfo, ".ProcessInput.PosSt");
        cpcExportGenericFunctions_get5AlertLimits(currentDP, dsDpParameters);
        cpcExportGenericFunctions_getAlarmActive(currentDP, dsDpParameters);
        cpcExportGenericFunctions_getArchive(currentDP, dsDpParameters);
        cpcExportGenericFunctions_getCategories(currentDP, dsDpParameters, exceptionInfo);
        cpcExportGenericFunctions_getKeyDeviceConfiguration(currentDP, dsDpParameters, CPC_CONFIG_SMS_MESSAGE, exceptionInfo);
        cpcExportGenericFunctions_get5AlertAcknowledgeAlarm(currentDP, ".ProcessInput.PosSt", dsDpParameters, exceptionInfo);
        cpcExportGenericFunctions_getArchiveNameForDpes(currentDP, UN_CONFIG_EXPORT_ARCHIVE_1, makeDynString(), dsDpParameters);
        cpcExportGenericFunctions_getArchiveNameForDpes(currentDP, UN_CONFIG_EXPORT_ARCHIVE_2, makeDynString("ProcessInput.PosSt"), dsDpParameters);
        cpcExportGenericFunctions_getArchiveNameForDpes(currentDP, UN_CONFIG_EXPORT_ARCHIVE_3, makeDynString("ProcessInput.evStsReg01"), dsDpParameters);
        cpcExportGenericFunctions_getMaskEvent(currentDP, dsDpParameters);

        unExportDevice_writeDsStringToFile(dsDpParameters, UN_PARAMETER_DELIMITER);
    }
}
void CMW_CPC_AnalogInput_ExportConfig(dyn_string dsDpList, dyn_string &exceptionInfo)
{
    string sObject = UN_CONFIG_CPC_ANALOGINPUT_DPT_NAME;
    int amount = dynlen(dsDpList);
    for(int i = 1; i <= amount; i++) {
        dyn_string dsDpParameters;
        string currentDP = dsDpList[i];

        if(!dpExists(currentDP)) continue;

        unExportDevice_getAllCommonParameters(currentDP, sObject, dsDpParameters);
        cpcExportGenericFunctions_getUnit(currentDP, dsDpParameters, ".ProcessInput.PosSt");
        cpcExportGenericFunctions_getFormat(currentDP, dsDpParameters, ".ProcessInput.PosSt");
        cpcExportGenericFunctions_getRange(currentDP, dsDpParameters, exceptionInfo, ".ProcessInput.PosSt");
        cpcExportGenericFunctions_get5AlertLimits(currentDP, dsDpParameters);
        cpcExportGenericFunctions_getAlarmActive(currentDP, dsDpParameters);
        cpcExportGenericFunctions_getDeadband(currentDP, dsDpParameters, exceptionInfo, ".ProcessInput.PosSt");
        cpcExportGenericFunctions_getArchive(currentDP, dsDpParameters);
        cpcExportGenericFunctions_getCategories(currentDP, dsDpParameters, exceptionInfo);
        cpcExportGenericFunctions_getKeyDeviceConfiguration(currentDP, dsDpParameters, CPC_CONFIG_SMS_MESSAGE, exceptionInfo);
        cpcExportGenericFunctions_get5AlertAcknowledgeAlarm(currentDP, ".ProcessInput.PosSt", dsDpParameters, exceptionInfo);
        cpcExportGenericFunctions_processCMWAddress(currentDP, sObject, "StsReg01",        true, dsDpParameters);
        cpcExportGenericFunctions_processCMWAddress(currentDP, sObject, "evStsReg01",      true, dsDpParameters);
        cpcExportGenericFunctions_processCMWAddress(currentDP, sObject, "PosSt",           true, dsDpParameters);
        cpcExportGenericFunctions_processCMWAddress(currentDP, sObject, "HFSt",  true, dsDpParameters);
        cpcExportGenericFunctions_getArchiveNameForDpes(currentDP, UN_CONFIG_EXPORT_ARCHIVE_1, makeDynString(), dsDpParameters);
        cpcExportGenericFunctions_getArchiveNameForDpes(currentDP, UN_CONFIG_EXPORT_ARCHIVE_2, makeDynString("ProcessInput.PosSt"), dsDpParameters);
        cpcExportGenericFunctions_getArchiveNameForDpes(currentDP, UN_CONFIG_EXPORT_ARCHIVE_3, makeDynString("ProcessInput.evStsReg01"), dsDpParameters);
        cpcExportGenericFunctions_getMaskEvent(currentDP, dsDpParameters);

        unExportDevice_writeDsStringToFile(dsDpParameters, UN_PARAMETER_DELIMITER);
    }
}
//end_TAG_SCRIPT_DEVICE_TYPE_CustomConfigFunctions


//@}